from calc_p_for_F import calc_p

class CANOVA_Rep:
    def __init__(self, Y):
        self.Y = Y

    def calc(self):
        N = len(self.Y)
        a = len(self.Y[0])
        print("a = %d     N = %d"%(a, N))

        Yid = []
        for i in range(0, N):
            sum = 0.0
            for j in range(0, a):
                sum += self.Y[i][j]
            Yid.append(sum / a)

        Ydj = []
        for j in range(0, a):
            sum = 0.0
            for i in range(0, N):
                sum += self.Y[i][j]
            Ydj.append(sum / N)
        sum = 0.0
        for j in range(0, a):
            sum += Ydj[j]
        Ydd = sum / a

        SS_A = 0.0
        SS_S = 0.0
        SS_SA = 0.0
        for i in range(0, N):
            for j in range(0, a):
                SS_A += (Ydj[j] - Ydd) ** 2.0
                SS_S += (Yid[i] - Ydd) ** 2.0
                SS_SA += (self.Y[i][j] - Yid[i] - Ydj[j] + Ydd) ** 2.0
        SS_T = SS_A + SS_S + SS_SA
        df_A = a - 1
        df_S = N - 1
        df_SA = (a - 1) * (N - 1)
        MS_A = SS_A / df_A
        MS_S = SS_S / df_S
        MS_SA = SS_SA / df_SA
        F = MS_A / MS_SA
        p = calc_p(F, df_A, df_SA)

        return  SS_S, SS_A, SS_SA, df_S, df_A, df_SA, MS_S, MS_A, MS_SA, F, p

        
