from calc_p_for_F import calc_p

Y = [[1, 3, 2],
     [5, 9, 7],
     [6, 12, 9]]

N = len(Y)
a = len(Y[0])
print("a = %d     N = %d"%(a, N))

Yid = []
for i in range(0, N):
    sum = 0.0
    for j in range(0, a):
        sum += Y[i][j]
    Yid.append(sum / a)

Ydj = []
for j in range(0, a):
    sum = 0.0
    for i in range(0, N):
        sum += Y[i][j]
    Ydj.append(sum / N)
sum = 0.0
for j in range(0, a):
    sum += Ydj[j]
Ydd = sum / a

SS_A = 0.0
SS_S = 0.0
SS_SA = 0.0
for i in range(0, N):
    for j in range(0, a):
        SS_A += (Ydj[j] - Ydd) ** 2.0
        SS_S += (Yid[i] - Ydd) ** 2.0
        SS_SA += (Y[i][j] - Yid[i] - Ydj[j] + Ydd) ** 2.0
SS_T = SS_A + SS_S + SS_SA
df_A = a - 1
df_S = N - 1
df_SA = (a - 1) * (N - 1)
MS_A = SS_A / df_A
MS_S = SS_S / df_S
MS_SA = SS_SA / df_SA
F = MS_A / MS_SA
p = calc_p(F, df_A, df_SA)

print()
print("%10s"%"Source", "%12s"%"SS", "%5s"%"df", "%12s"%"MS", "%12s"%"F")
print("%10s"%"S", "%12.3f"%SS_S, "%5d"%df_S, "%12.3f"%MS_S)
print("%10s"%"A", "%12.3f"%SS_A, "%5d"%df_A, "%12.3f"%MS_A, "%12.3f"%F,
      "   p = %-10.5f"%(1.0 - p))
print("%10s"%"SA", "%12.3f"%SS_SA, "%5d"%df_SA, "%12.3f"%MS_SA)



